<template>
  <div class="registration-subscription">
    <p class="title-component">
      {{ $t('bounty.registration.title') }}
    </p>

    <div class="registration-subscription__content">
      <div class="registration-subscription-item" v-for="item in registrationList">
        <p class="desc">
          {{ item.desc }}
        </p>

        <div class="box">
          {{ getToken(item.type) | formatCurrencyAmount('heta', '0') }}
        </div>
      </div>
    </div>

    <div class="ctu-total">
      <p class="title">{{ $t('common.heta_tokens') }}</p>
      <div class="number">{{ total | formatCurrencyAmount('heta', '0') }}</div>
    </div>
  </div>
</template>

<script>
import rf from '../../../common/requests/RequestFactory';
import bignumber from 'bignumber.js';

export default {
  data() {
    return {
      data: [],
      total: 0,
      registrationList: [
        {
          desc: 'Account registration',
          type: 'register'
        },
        {
          desc: 'Verify KYC',
          type: 'kyc'
        },
        {
          desc: 'Make the first deposit',
          type: 'deposit'
        }
      ]
    }
  },
  methods: {
    getToken (type) {
      const bounty = this.data.find(item => item.type === type);
      return (bounty && bounty.status === 'approved') ? bounty.heta_tokens : 0;
    },
    async getBountyRegister () {
      const result = await rf.getRequest('BountyRequest').getBountyRegister();
      this.data = result.data;
      this.total = this.data
                    .filter(item => item.status === 'approved')
                    .reduce((sum, item) => {
                      return bignumber(sum).plus(item.heta_tokens);
                    }, bignumber('0')).toString();
    },
  },
  created () {
    this.getBountyRegister();
  },
}
</script>

<style scoped lang="scss">
  @import '../../../../sass/variables';
  .title-component {
    margin-bottom: 25px;
  }
  .registration-subscription {
    padding: 30px 0;
  }

  .registration-subscription__content {
    margin-bottom: 5px;
  }

  .registration-subscription-item {
    margin-bottom: 10px;
    width: 65%;
    max-width: 500px;

    .desc {
      font-size: $small;
      width: 150px;
      margin-bottom: 3px;
      display: inline-block;
      vertical-align: middle;
      color: $gray;
    }

    .box {
      border-radius: 74px;
      border: 1px solid #d2d2d2;
      background-color:  #ffffff;
      width: 300px;
      display: inline-block;
      vertical-align: middle;
      padding: 7px 25px;
      font-weight: bold;
    }

    &:last-child {
      margin-bottom: 0;
    }
  }

  .ctu-total {
    padding-top: 6px;

    .title {
      width: 150px !important;
      margin-right: 0 !important;
    }
  }
</style>
